#include <stdio.h>
typedef struct cvor *POKAZIVAC;
typedef struct cvor{
	int broj;
	POKAZIVAC sledeci;
}CVOR;
typedef struct glavaRep {
	POKAZIVAC glava;
	POKAZIVAC rep;
}*LISTA;
void inicijalizuj_listu(LISTA *lista){
	(*lista) = malloc(sizeof(CVOR));
	(*lista)->glava = NULL;
	(*lista)->rep = NULL;
}
void ubaci_na_kraj_I(POKAZIVAC *glava, POKAZIVAC *rep, int broj){
	POKAZIVAC novi_cvor;
	novi_cvor = malloc(sizeof(CVOR));
	novi_cvor->broj = broj;
	novi_cvor->sledeci = NULL;
	if(*glava == NULL){
		*glava = novi_cvor;
		*rep = novi_cvor;
	} else {
		(*rep)->sledeci = novi_cvor;
		*rep = novi_cvor;
	}
}
void ubaci_na_pocetak_I(POKAZIVAC *glava, POKAZIVAC *rep, int broj){
	POKAZIVAC novi_cvor;
	novi_cvor = malloc(sizeof(CVOR));
	novi_cvor->broj = broj;
	novi_cvor->sledeci = NULL;
	if(*glava == NULL){
		*glava = novi_cvor;
		*rep = novi_cvor;
	} else {
		novi_cvor->sledeci = *glava;
		*glava = novi_cvor;
	}
}
void ubaci_na_kraj_II(LISTA lista, int broj){
	POKAZIVAC novi_cvor;
	novi_cvor = malloc(sizeof(CVOR));
	novi_cvor->broj = broj;
	novi_cvor->sledeci = NULL;
	if(lista->glava == NULL){
		lista->glava = novi_cvor;
		lista->rep = novi_cvor;
	} else {
		lista->rep->sledeci = novi_cvor;
		lista->rep = novi_cvor;
	}
}
void ubaci_na_pocetak_II(LISTA lista, int broj){
	POKAZIVAC novi_cvor;
	novi_cvor = malloc(sizeof(CVOR));
	novi_cvor->broj = broj;
	novi_cvor->sledeci = NULL;
	if(lista->glava == NULL){
		lista->glava = novi_cvor;
		lista->rep = novi_cvor;
	} else {
		novi_cvor->sledeci = lista->glava;
		lista->glava = novi_cvor;
	}
}
void izbaci_sa_pocetka_I(POKAZIVAC *glava){
	POKAZIVAC tek;
	if(*glava == NULL) return;

	if((*glava)->sledeci == NULL){
		tek = *glava;
		*glava = NULL;
		free(tek);
	} else {
		tek = *glava;
		*glava = (*glava)->sledeci;
		free(tek);
	}
}

void izbaci_sa_pocetka_II(LISTA lista){
	POKAZIVAC tek;
	if(lista->glava == NULL) return;

	if(lista->glava->sledeci == NULL){
		tek = lista->glava;
		lista->glava = NULL;
		lista->rep = NULL;
		free(tek);
	} else {
		tek = lista->glava;
		lista->glava = lista->glava->sledeci;
		free(tek);
	}
}
void izbaci_sa_kraja_I(POKAZIVAC *glava){
	POKAZIVAC tek;
	if(*glava == NULL) return;

	if((*glava)->sledeci == NULL){
		tek = *glava;
		*glava = NULL;
		free(tek);
	} else {
		POKAZIVAC pom = *glava;
		while(pom->sledeci->sledeci != NULL){
			pom = pom->sledeci;
		}
		tek = pom->sledeci;
		pom->sledeci = NULL;
		free(tek);
	}
}
void izbaci_sa_kraja_II(LISTA lista){
	POKAZIVAC tek;
	if(lista->glava == NULL) return;

	if(lista->glava->sledeci == NULL){
		tek = lista->glava;
		lista->glava = NULL;
		lista->rep = NULL;
		free(tek);
	} else {
		POKAZIVAC pom = lista->glava;
		while(pom->sledeci->sledeci != NULL){
			pom = pom->sledeci;
		}
		tek = pom->sledeci;
		pom->sledeci = NULL;
		free(tek);
	}
}
POKAZIVAC pronadji_element(LISTA lista, int broj){
	POKAZIVAC tek = lista->glava;
	while(tek != NULL && tek->broj != broj){
		tek = tek->sledeci;
	}
	return tek;
}
void prikazi_listu_I(POKAZIVAC glava){
	POKAZIVAC tek = glava;
	printf("LISTA:\n");
	while(tek != NULL){
		printf("%3d\t", tek->broj);
		tek = tek->sledeci;
	}
	printf("\n");
}
void prikazi_listu_II(LISTA lista){
	POKAZIVAC tek = lista->glava;
	printf("LISTA:\n");
	while(tek != NULL){
		printf("%3d\t", tek->broj);
		tek = tek->sledeci;
	}
	printf("\n");
}
int main(){
	// Ukoliko ne koristimo strukturu LISTA nego samo pokazivace na cvorove
	// Moracemo da vodimo evidenciju o pokazivacima: glava i rep;
	// Imamo vise koda za razliku kad koristimo strukturu LISTA

	POKAZIVAC glava = NULL;
	POKAZIVAC rep = NULL;
	// Ukoliko koristimo strukturu LISTA
	// Na pocetku samo postavimo pocetne vrijednosti elemenata strukture LISTA (glava i rep) na NULL i zauzmemo potrebni memorijski prostor
	// Laksi nacin za rad sa listama, lak pristup pokazivacima na pocetak i kraj liste
	// Nema potrebe za cuvanjem pokazivaca na glavu i rep.
	LISTA lista;

	POKAZIVAC pronadjen;

	ubaci_na_kraj_I(&glava, &rep, 6);
	ubaci_na_kraj_I(&glava, &rep, 8);
	ubaci_na_kraj_I(&glava, &rep, 3);
	ubaci_na_pocetak_I(&glava, &rep, 44);
	izbaci_sa_pocetka_I(&glava);
	izbaci_sa_kraja_I(&glava);
	prikazi_listu_I(glava);

	inicijalizuj_listu(&lista);
	ubaci_na_kraj_II(lista, 5);
	ubaci_na_kraj_II(lista, 7);
	ubaci_na_kraj_II(lista, 3);
	ubaci_na_pocetak_II(lista, 14);
	izbaci_sa_pocetka_II(lista);
	izbaci_sa_kraja_II(lista);
	prikazi_listu_II(lista);

	pronadjen = pronadji_element(lista, 7);
	printf("Pronadjen broj u cvoru je: %d\n", pronadjen->broj);

	return 0;
}
